﻿Type=Class
Version=3.82
B4A=true
@EndOfDesignText@

'Class module
Sub Class_Globals
	Private et As EditText
	Private vr As VoiceRecognition
	Private btn As Button
End Sub

Public Sub Initialize (TargetModule As Object, EventName As String)
	vr.Initialize("vr")
End Sub

Public Sub DesignerCreateView(base As Panel, lbl As Label, Props As Map)
	btn.Initialize("btn")
	base.AddView(btn, 0, 0, base.Width, base.Height)
	btn.Background = LoadResourceDrawable(17301668) 'R.drawable.ic_btn_speak_now
	btn.Enabled = vr.IsSupported
End Sub

Private Sub btn_Click
	vr.Listen
End Sub

Private Sub vr_Result (Success As Boolean, Texts As List)
	If Success AND Texts.Size > 0 Then
		et.Text = Texts.Get(0)
	End If
End Sub

Public Sub setTargetEditText(val As EditText)
	et = val
End Sub

Public Sub setIcon(bmp As Bitmap)
	Dim bd As BitmapDrawable
	bd.Initialize(bmp)
	btn.Background = bd
End Sub

Public Sub setLanguage(val As String)
	vr.Language = val
End Sub

Private Sub LoadResourceDrawable(id As Int) As Object
'	Dim r As Reflector
'    r.Target = r.GetContext
'    r.Target = r.RunMethod("getResources")
'	Return r.RunMethod2("getDrawable", id, "java.lang.int")


	'******************************************************
	'We can code other strategies by spliting 2 sub modules
	'*******************************************************
	Dim r As Reflector
	r.Target =GetResources
	r.Target=GetDrawable(id)
	Return r.Target
End Sub
'Used in the case using JavaObject Library
Sub GetContext As JavaObject
   Return GetBA.GetField("context")
End Sub
'Used in the case using JavaObject Library
Sub GetBA As JavaObject
  Dim jo As JavaObject
  Dim cls As String = Me '<=  Me is a keyword. It returns a reference to the current module (class, activity or service)
  cls = cls.SubString("class ".Length)
  jo.InitializeStatic(cls)
  Return jo.GetFieldJO("processBA")
End Sub
'The first sub module
Private Sub GetResources As Object
   
'    Dim r1 As Reflector
'    r1.Target = r1.GetContext
'    Return r1.RunMethod("getResources")
   
   '************************************************************
   ' We can use JavaObject library instead of Reflector library
   '************************************************************
     Dim jo1 As JavaObject=GetContext
     Return jo1.RunMethodJO("getResources", Null)
	
End Sub


'The second sub module
Private Sub GetDrawable(id As Int) As Object
'    Dim r2 As Reflector
'	r2.Target = GetResources    '<--- without it the reflector object will be null
'    Return r2.RunMethod2("getDrawable", id, "java.lang.int")
	
   '************************************************************
   ' We can use JavaObject library instead of Reflector library
   '************************************************************
         Dim jo2 As JavaObject=GetResources
		 Return jo2.RunMethod("getDrawable", Array(id))
         
End Sub